<?php

/*----------------------------------------------------------------------------------|  simontech.me  |----/


				Award Manager by SimonTech Development 


/-------------------------------------------------------------------------------------------------------/





	@version		1.0.7


	@build			8th June, 2019


	@created		19th April, 2019


	@package		Award Manager


	@subpackage		controller.php


	@author			SimonTech <https://simontech.me>	


	@copyright		Copyright (C) 2019 SimonTech Development. All Rights Reserved


	@license		GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html


  ____  _____  _____  __  __  __      __       ___  _____  __  __  ____  _____  _  _  ____  _  _  ____ 


 (_  _)(  _  )(  _  )(  \/  )(  )    /__\     / __)(  _  )(  \/  )(  _ \(  _  )( \( )( ___)( \( )(_  _)


.-_)(   )(_)(  )(_)(  )    (  )(__  /(__)\   ( (__  )(_)(  )    (  )___/ )(_)(  )  (  )__)  )  (   )(  


\____) (_____)(_____)(_/\/\_)(____)(__)(__)   \___)(_____)(_/\/\_)(__)  (_____)(_)\_)(____)(_)\_) (__) 





/------------------------------------------------------------------------------------------------------*/





// No direct access to this file


defined('_JEXEC') or die('Restricted access');





/**


 * General Controller of Award_manager component


 */


class Award_managerController extends JControllerLegacy


{


	/**


	 * Constructor.


	 *


	 * @param   array  $config  An optional associative array of configuration settings.


	 * Recognized key values include 'name', 'default_task', 'model_path', and


	 * 'view_path' (this list is not meant to be comprehensive).


	 *


	 * @since   3.0


	 */


	public function __construct($config = array())


	{


		// set the default view


		$config['default_view'] = 'nominees';





		parent::__construct($config);


	}





	/**


	 * display task


	 *


	 * @return void


	 */


	function display($cachable = false, $urlparams = false)


	{


		// set default view if not set


		$view   = $this->input->getCmd('view', 'nominees');


		$data	= $this->getViewRelation($view);


		$layout	= $this->input->get('layout', null, 'WORD');


		$id    	= $this->input->getInt('id');





		// Check for edit form.


		if(Award_managerHelper::checkArray($data))


		{


			if ($data['edit'] && $layout == 'edit' && !$this->checkEditId('com_award_manager.edit.'.$data['view'], $id))


			{


				// Somehow the person just went to the form - we don't allow that.


				$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_UNHELD_ID', $id));


				$this->setMessage($this->getError(), 'error');


				// check if item was opend from other then its own list view


				$ref 	= $this->input->getCmd('ref', 0);


				$refid 	= $this->input->getInt('refid', 0);


				// set redirect


				if ($refid > 0 && Award_managerHelper::checkString($ref))


				{


					// redirect to item of ref


					$this->setRedirect(JRoute::_('index.php?option=com_award_manager&view='.(string)$ref.'&layout=edit&id='.(int)$refid, false));


				}


				elseif (Award_managerHelper::checkString($ref))


				{





					// redirect to ref


					$this->setRedirect(JRoute::_('index.php?option=com_award_manager&view='.(string)$ref, false));


				}


				else


				{


					// normal redirect back to the list view


					$this->setRedirect(JRoute::_('index.php?option=com_award_manager&view='.$data['views'], false));


				}





				return false;


			}


		}





		return parent::display($cachable, $urlparams);


	}





	protected function getViewRelation($view)


	{


		// check the we have a value


		if (Award_managerHelper::checkString($view))


		{


			// the view relationships


			$views = array(

				'nominee' => 'nominees'


					);


			// check if this is a list view


			if (in_array($view, $views))


			{


				// this is a list view


				return array('edit' => false, 'view' => array_search($view,$views), 'views' => $view);


			}


			// check if it is an edit view


			elseif (array_key_exists($view, $views))


			{


				// this is a edit view


				return array('edit' => true, 'view' => $view, 'views' => $views[$view]);


			}


		}


		return false;


	}


}


