<?php
/*----------------------------------------------------------------------------------|  simontech.me  |----/
				Award Manager by SimonTech Development
/-------------------------------------------------------------------------------------------------------/

	@version		1.1.0
	@build			9th July, 2019
	@created		19th April, 2019
	@package		Award Manager
	@subpackage		view.html.php
	@author			SimonTech <https://simontech.me>
	@copyright		Copyright (C) 2019 SimonTech Development. All Rights Reserved
	@license		GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
  ____  _____  _____  __  __  __      __       ___  _____  __  __  ____  _____  _  _  ____  _  _  ____
 (_  _)(  _  )(  _  )(  \/  )(  )    /__\     / __)(  _  )(  \/  )(  _ \(  _  )( \( )( ___)( \( )(_  _)
.-_)(   )(_)(  )(_)(  )    (  )(__  /(__)\   ( (__  )(_)(  )    (  )___/ )(_)(  )  (  )__)  )  (   )(
\____) (_____)(_____)(_/\/\_)(____)(__)(__)   \___)(_____)(_/\/\_)(__)  (_____)(_)\_)(____)(_)\_) (__)

/------------------------------------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Award_manager View class
 */
class Award_managerViewDashboard extends JViewLegacy
{
	/**
	 * View display method
	 * @return void
	 */
	function display($tpl = null)
	{

		if ($this->getLayout() !== 'modal')
		{
			// Include helper submenu
			Award_managerHelper::addSubmenu('dashboard');
		}
		// Assign data to the view
		$this->icons			= $this->get('Icons');
		$this->items 			= $this->get('Items');
		//$this->stats = $this->get('Votestats');
		$this->contributors		= Award_managerHelper::getContributors();

		// get the manifest details of the component
		$this->manifest = Award_managerHelper::manifest();

		// Set the toolbar
		$this->addToolBar();

		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			throw new Exception(implode("\n", $errors), 500);
		}

		// Display the template
		parent::display($tpl);

		// Set the document
		$this->setDocument();
	}

	/**
	 * Setting the toolbar
	 */
	protected function addToolBar()
	{
		$canDo = Award_managerHelper::getActions('award_manager');
		JToolBarHelper::title(JText::_('COM_AWARD_MANAGER_DASHBOARD'), 'grid-2');

		// set help url for this view if found
		$help_url = Award_managerHelper::getHelpUrl('award_manager');
		if (Award_managerHelper::checkString($help_url))
		{
			JToolbarHelper::help('COM_AWARD_MANAGER_HELP_MANAGER', false, $help_url);
		}

		if ($canDo->get('core.admin') || $canDo->get('core.options'))
		{
			JToolBarHelper::preferences('com_award_manager');
		}
	}

	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument()
	{
		$document = JFactory::getDocument();

		// add dashboard style sheets
		$document->addStyleSheet(JURI::root() . "administrator/components/com_award_manager/assets/css/dashboard.css");
		$document->addStyleSheet("https://cdn.datatables.net/1.10.16/css/jquery.dataTables.min.css", (Award_managerHelper::jVersion()->isCompatible("3.8.0")) ? array("version" => "auto") : "text/css");
		$document->addScript("https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js", (Award_managerHelper::jVersion()->isCompatible("3.8.0")) ? array("version" => "auto") : "text/javascript");

		// set page title
		$document->setTitle(JText::_('COM_AWARD_MANAGER_DASHBOARD'));

		// add manifest to page JavaScript
		$document->addScriptDeclaration("var manifest = jQuery.parseJSON('" . json_encode($this->manifest) . "');", "text/javascript");
	}
}
