<?php



/**

 * @author simontech.me

 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.

 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

 * Websites: http://www.thePHPfactory.com

 * Technical Support: Forum - http://www.thePHPfactory.com/forum/



*/



defined('_JEXEC') or die;



JLoader::register('Award_managerController', JPATH_COMPONENT . '/controller.php');



class Award_managerControllerVote extends Award_managerController

{

    public function index()

    {

        $resourceType = $this->input->getCmd('type');

        $resourceId = $this->input->getInt('id');



        $model = $this->getModel('Votes', 'Award_managerModel');



        $votes = $model->findVotes($resourceType, $resourceId);



        echo JLayoutHelper::render('vote.votes', array(

            'votes' => $votes,

        ));



        //var_dump($Votes);

        //jexit();

    }



    public function register()

    {

        $response = array();

        $resourceType = $this->input->getString('type');

        $resourceId = $this->input->getInt('id');

        $user = JFactory::getUser();



        $model = $this->getModel('Vote', 'Award_managerModel');



        try {

            $model->register($resourceType, $resourceId, $user->id);



            $response['success'] = true;

            $response['html'] = JHtml::_('Award_manager.Helper.vote', true, $resourceType, $resourceId);

            $response['message'] = JText::_('vote_task_submit_success');

            //$response['votes'] = $this->getVotes($resourceType, $resourceId);

            $response['resource']['type'] = $resourceType;

            $response['resource']['id'] = $resourceId;

        } catch (Exception $e) {

            $response['success'] = false;

            $response['message'] = JText::_('vote_task_submit_error');

            $response['error'] = $e->getMessage();

        }



        echo json_encode($response);

        jexit();



    }



    private function getVotes($resourceType, $resourceId)

    {

        $repo = $this->getModel('Votes', 'Award_managerModel');



        $totals = $repo->countForResources($resourceType, array($resourceId));

        $total = isset($totals[$resourceId]['votes']) ? $totals[$resourceId]['votes'] : 0;



        return JHtml::_('Award_manager.Helper.votes', $total, $resourceType, $resourceId);

    }



    public function remove()

    {

        $response = array();

        $resourceType = $this->input->getString('type');

        $resourceId = $this->input->getInt('id');

        $user = JFactory::getUser();



        $model = $this->getModel('Vote', 'Award_managerModel');



        try {

            $model->remove($resourceType, $resourceId, $user->id);



            $response['success'] = true;

            $response['html'] = JHtml::_('Award_manager.Helper.vote', false, $resourceType, $resourceId);

            $response['message'] = JText::_('vote_task_remove_success');

            //$response['votes'] = $this->getVotes($resourceType, $resourceId);

            $response['resource']['type'] = $resourceType;

            $response['resource']['id'] = $resourceId;

        } catch (Exception $e) {

            $response['success'] = false;

            $response['message'] = JText::_('vote_task_remove_error');

            $response['error'] = $e->getMessage();

        }



        echo json_encode($response);

        jexit();

    }



    public function latest($user_id)

    {

        $repo = $this->getModel('Users', 'Award_managerModel');

        $posts = $repo->findLatestVotesByUser($user_id, 20);



        return $this->render('post._list', array(

            'posts'    => $posts,

            'comments' => false,

        ));

    }

}

